/*
 * 错误配置
 * 错误数据格式 {code:'错误代码',msg:'错误说明',native:'原生错误信息Error对象'}
 *
 * */
export const errorConfig = {
	//通用错误代码
	common_error: {
		code: 600,
		msg: 'common error'
	},

	//以后未登录的通用错误其他不要用了
	no_login: {
		code: 1001,
		msg: 'please log in first'
	},

	//没有数据
	no_data: {
		code: 130,
		msg: 'Data does not exist!'
	},


	//这是联系人的数据类型
	contact_type: {
		code: 140,
		msg: "This is the contact\'s data"
	},

	//这是公司的数据类型
	company_type: {
		code: 141,
		msg: 'This is company data'
	},


	//被拒绝访问
	no_access: {
		code: 403,
		msg: 'No access'
	},

	//超时
	timeout_error: {
		code: 411,
		msg: 'timeout'
	},

	//网络错误
	network_error: {
		code: 410,
		msg: 'Network Error'
	},

	//图片错误
	img_error: {
		code: 412,
		msg: 'Image failed'
	},

	file_error: {
		code: 413,
		msg: 'File failed'
	},

	//图片错误
	img_not_found: {
		code: 414,
		msg: "The picture doesn't exist"
	},

	//没有找到，没有连接
	not_found: {
		code: 404,
		msg: 'Not found'
	},

	//访问频率过快了
	frequency_too_fast: {
		code: 404,
		msg: 'The request frequency is too fast, please rest and try again!'
	},

	linkedin_vpn: {
		code: 700,
		msg: 'Due to the limitation of linkedin, you need to open vpn and put linkedin in the over-the-wall list!'
	},

	//参数错误
	parameter_error: {
		code: 1000,
		msg: 'parameter error'
	},

	//验证内容错误
	validate_error: {
		code: 1001,
		msg: 'validate error'
	},

	//代码/语法错误，这种错误一般需要联系程序负责人
	syntax_error: {
		code: 2000,
		msg: 'Syntax error, Please contact the program manager'
	},

	//采集数据不匹配，采集数据过程中，发生无法采集的数据，一般可能是采集的网站发生变化；需要重新匹配
	collection_error: {
		code: 2001,
		msg: ''
	},

	//用户取消操作
	abort_error: {
		code: 3000,
		msg: '用户取消操作'
	},

	//用户取消操作
	verstion_error: {
		code: 4000,
		msg: '版本号不对'
	}
}

export default Object.freeze(errorConfig)
