/// <reference path="../types.d.ts"/>
import './preload-main'
import util, {MezzFileType, MqttStatus, Util, LiveActionType} from '../common/util'
import gc from './gc'
import Ajax from '../common/ajax'
import {BrowserView, WebContents} from 'electron'
import error from '../common/error'
import env from '../common/env'
import * as Gc from '../gc.type'

/**
 * @用途
 * @author 黄敏
 * @创建时间 2022-08-02 15:15
 **/

type ValueOf<T> = T[keyof T]

declare global {
  namespace ff {
    type MezzFileType = ValueOf<typeof MezzFileType>
    type MqttStatus = ValueOf<typeof MqttStatus>
    type LiveActionType = ValueOf<typeof LiveActionType>
    //gc全局
    namespace gc {
      type KeyboardShortcut = Gc.KeyboardShortcut
      type Client = Gc.Client
      type Subscribes = Gc.Subscribes
    }
  }
  var ff: {
    MqttStatus: typeof MqttStatus
    LiveActionType: typeof LiveActionType
    env: typeof env
    error: typeof error
    util: Util
    gc: ff.gc.Client
    Ajax: typeof Ajax
    //用户信息 store
    userInfo: User.UserInfo | null
    //cm列表
    cmList: User.CMItem[]
    browsers: {[id: string]: BrowserView} //打开的浏览器集合

    currentBrowserTab?: WebContents //当 前显示的浏览器tab页
    //显示中的窗口
    show_popup: {
      [key: string]: boolean
    }
    //当前的tab页，位置
    $tabId: number
  }
}

global.ff = {
  MqttStatus,
  LiveActionType,
  env,
  error,
  util,
  Ajax,
  gc,
  userInfo: null,
  cmList: [],
  browsers: {},
  show_popup: {},
  $tabId: -10
}
