/**
 * @用途
 * @author 黄敏
 * @创建时间 2022-08-19 16:11
 **/

import {ipcMain, IpcMainEvent, session} from 'electron'
import CookiesSetDetails = Electron.CookiesSetDetails;

ipcMain.on('getUserInfo', (e: IpcMainEvent) => {
  e.returnValue = ff.userInfo
})

//获取cmList数据
ipcMain.on('getCmList', (e: IpcMainEvent) => {
  e.returnValue = ff.cmList
})

//获取windowBrowser id
ipcMain.on('getWebContentId', (e: IpcMainEvent) => {
  e.returnValue = e.sender.id
})

//请求更新插件
ipcMain.on('updateExtension',()=>{
    ff.gc.send('重新获取扩展列表')
})

//获取cookie
type CookiesGetFilter = Electron.CookiesGetFilter
ipcMain.handle('get-cookie', async (e: any, data: CookiesGetFilter) => {
  const result = await session.defaultSession.cookies.get(data)
  return result
})


ipcMain.handle('set-cookie', async (e: any, data: CookiesSetDetails) => {
  const result = await session.defaultSession.cookies.set(data)
  return result
})
