/// <reference path="../types.d.ts"/>
import mqttHandle, {MqttHandle} from './src/mqtt'
import gcHandle, {GcHandle} from './src/gc'
import browserHandle, {BrowserHandle} from './src/browser'
import path from 'path'
import {contextBridge, ipcRenderer} from 'electron'
/**
 * @用途
 * @author 黄敏
 * @创建时间 2022-08-19 08:14
 **/
let _glob = {
  browser: browserHandle,
  mqtt: mqttHandle,
  gc: gcHandle,
  __dirname: path.join(__dirname, '..'),
  getWebContentId: () => ipcRenderer.sendSync('getWebContentId'),
  //获取userInfo
  getUserInfo: () => ipcRenderer.sendSync('getUserInfo'),
  //获取cm列表
  getCmList: () => ipcRenderer.sendSync('getCmList'),
  getCookie: (args: Electron.CookiesGetFilter) => ipcRenderer.invoke('get-cookie', args),
  setCookie: (args: Electron.CookiesSetDetails) => ipcRenderer.invoke('set-cookie', args),
}

contextBridge.exposeInMainWorld('_pre_', _glob)

declare global {
  var _pre_: Readonly<{
    browser: BrowserHandle
    gc: GcHandle
    mqtt: MqttHandle
    __dirname: string
    getWebContentId(): number
    //获取用户数据
    getUserInfo(): User.UserInfo
    //获取cm列表
    getCmList(): User.CMItem[]
    getCookie(data: Electron.CookiesGetFilter): Promise<Electron.Cookie[]>
    setCookie(data: Electron.CookiesSetDetails): Promise<void>
  }>
}

window._pre_ = _glob
