/**
 * @用途
 * @author 黄敏
 * @创建时间 2021-12-19 23:16
 **/

import {ipcRenderer} from 'electron'

interface closeEvent {
  (): void
}

//浏览器
export interface BrowserHandle {
  //标签页初始数据更变
  onTabInitChange(on: (newTab: f2.tab.Browser) => void): closeEvent

  //在浏览器上开始拖曳
  ondragstart(on: () => void): closeEvent

  //在浏览器上结束拖曳
  ondragstop(on: () => void): closeEvent
}

const browserHandle: BrowserHandle = {
  //标签页初始数据更变
  onTabInitChange: cb => {
    let cb2 = (e: Electron.IpcRendererEvent, d: f2.tab.Browser) => cb(d)
    ipcRenderer.on('change-tab', cb2)

    return () => {
      ipcRenderer.removeListener('change-tab', cb2)
    }
  },

  //在浏览器上开始拖曳
  ondragstart: cb => {
    ipcRenderer.on('browser-ondragstart', cb)
    return () => {
      ipcRenderer.removeListener('change-tab', cb)
    }
  },
  //在浏览器上结束拖曳
  ondragstop: cb => {
    ipcRenderer.on('browser-ondragstop', cb)
    return () => {
      ipcRenderer.removeListener('change-tab', cb)
    }
  }
}

export default browserHandle
