/**
 * @用途
 * @author 黄敏
 * @创建时间 2021-12-19 22:18
 **/

//ipc客户端
import {ipcRenderer} from 'electron'

//ipc客户端
export interface GcHandle {
  removeClient: (webContentId: number) => void
  onmessage: (on: (topic: string, ...message: any) => void) => void
  send: (topic: string, ...message: any) => void

  sendMain: (topic: string, ...message: any) => void
  subscribes: (tipics: string[], webContentId: number) => void
  unsubscribes: (tipics: string[], webContentId: number) => void
}

const gcHandle: GcHandle = {
  removeClient: webContentId => ipcRenderer.send('$ipc/remove/client', webContentId),
  onmessage: (on: (topic: string, ...message: any) => void) => {
    ipcRenderer.on('$ipc/message', (event, topic, ...message) => {
      on(topic, ...message)
    })
  },
  send: (topic, ...message) => ipcRenderer.send('$ipc/send', topic, ...message),
  sendMain: (topic, ...message) => ipcRenderer.send('$ipc/sendmain', topic, ...message),
  subscribes: (tipics, webContentId) => ipcRenderer.send('$ipc/subscribes', tipics, webContentId),
  unsubscribes: (tipics, webContentId) => ipcRenderer.send('$ipc/unsubscribes', tipics, webContentId)
}

export default gcHandle
