/**
 * @用途
 * @author 黄敏
 * @创建时间 2021-12-19 22:01
 **/

//mqtt客户端
import {ipcRenderer} from 'electron'

//mqtt客户端
export interface MqttHandle {
  //刷新mqtt状态
  refreshStatus: () => void
  subscribes: (tipics: string[], webContentId: number) => void
  unsubscribes: (tipics: string[], webContentId: number) => void
  removeClient: (webContentId: number) => void
  onmessage: (on: (topic: string, message: any, isLocal?: boolean) => void) => void
  localPublish: (topic: string, ...message: any) => void
  publish: (topic: string, ...message: any) => void
}

const mqttHandle: MqttHandle = {
  //刷新mqtt状态
  refreshStatus: () => ipcRenderer.send('$mqtt/status'),
  removeClient: webContentId => ipcRenderer.send('remove-mqtt-client', webContentId),
  onmessage: on => {
    ipcRenderer.on('mqtt-message', (event, topic: string, message: any, isLocal?: boolean) => {
      on(topic, message, isLocal)
    })
  },
  localPublish: (topic: string, message: any) => ipcRenderer.send('mqtt-local-publich', topic, message),
  publish: (topic: string, message: any) => ipcRenderer.send('mqtt-publich', topic, message),
  subscribes: (tipics, webContentId) => ipcRenderer.send('mqtt-subscribes', tipics, webContentId),
  unsubscribes: (tipics, webContentId) => ipcRenderer.send('mqtt-unsubscribes', tipics, webContentId)
}

export default mqttHandle
