export interface CountryBase {
  id: number
  en_name: string
  zh_name: string
  keywords?: string[] //搜索匹配关键字，只能用小写，不然无法匹配
  code:
    | 'AC'
    | 'AD'
    | 'AE'
    | 'AF'
    | 'AG'
    | 'AI'
    | 'AL'
    | 'AM'
    | 'AO'
    | 'AR'
    | 'AS'
    | 'AT'
    | 'AU'
    | 'AW'
    | 'AX'
    | 'AZ'
    | 'BA'
    | 'BB'
    | 'BD'
    | 'BE'
    | 'BF'
    | 'BG'
    | 'BH'
    | 'BI'
    | 'BJ'
    | 'BL'
    | 'BM'
    | 'BN'
    | 'BO'
    | 'BQ'
    | 'BR'
    | 'BS'
    | 'BT'
    | 'BW'
    | 'BY'
    | 'BZ'
    | 'CA'
    | 'CC'
    | 'CD'
    | 'CF'
    | 'CG'
    | 'CH'
    | 'CI'
    | 'CK'
    | 'CL'
    | 'CM'
    | 'CN'
    | 'CO'
    | 'CR'
    | 'CU'
    | 'CV'
    | 'CW'
    | 'CX'
    | 'CY'
    | 'CZ'
    | 'DE'
    | 'DJ'
    | 'DK'
    | 'DM'
    | 'DO'
    | 'DZ'
    | 'EC'
    | 'EE'
    | 'EG'
    | 'EH'
    | 'ER'
    | 'ES'
    | 'ET'
    | 'FI'
    | 'FJ'
    | 'FK'
    | 'FM'
    | 'FO'
    | 'FR'
    | 'GA'
    | 'GB'
    | 'GD'
    | 'GE'
    | 'GF'
    | 'GG'
    | 'GH'
    | 'GI'
    | 'GL'
    | 'GM'
    | 'GN'
    | 'GP'
    | 'GQ'
    | 'GR'
    | 'GT'
    | 'GU'
    | 'GW'
    | 'GY'
    | 'HK'
    | 'HN'
    | 'HR'
    | 'HT'
    | 'HU'
    | 'ID'
    | 'IE'
    | 'IL'
    | 'IM'
    | 'IN'
    | 'IO'
    | 'IQ'
    | 'IR'
    | 'IS'
    | 'IT'
    | 'JE'
    | 'JM'
    | 'JO'
    | 'JP'
    | 'KE'
    | 'KG'
    | 'KH'
    | 'KI'
    | 'KM'
    | 'KN'
    | 'KP'
    | 'KR'
    | 'KW'
    | 'KY'
    | 'KZ'
    | 'LA'
    | 'LB'
    | 'LC'
    | 'LI'
    | 'LK'
    | 'LR'
    | 'LS'
    | 'LT'
    | 'LU'
    | 'LV'
    | 'LY'
    | 'MA'
    | 'MC'
    | 'MD'
    | 'ME'
    | 'MF'
    | 'MG'
    | 'MH'
    | 'MK'
    | 'ML'
    | 'MM'
    | 'MN'
    | 'MO'
    | 'MP'
    | 'MQ'
    | 'MR'
    | 'MS'
    | 'MT'
    | 'MU'
    | 'MV'
    | 'MW'
    | 'MX'
    | 'MY'
    | 'MZ'
    | 'NA'
    | 'NC'
    | 'NE'
    | 'NF'
    | 'NG'
    | 'NI'
    | 'NL'
    | 'NO'
    | 'NP'
    | 'NR'
    | 'NU'
    | 'NZ'
    | 'OM'
    | 'PA'
    | 'PE'
    | 'PF'
    | 'PG'
    | 'PH'
    | 'PK'
    | 'PL'
    | 'PM'
    | 'PR'
    | 'PS'
    | 'PT'
    | 'PW'
    | 'PY'
    | 'QA'
    | 'RE'
    | 'RO'
    | 'RS'
    | 'RU'
    | 'RW'
    | 'SA'
    | 'SB'
    | 'SC'
    | 'SD'
    | 'SE'
    | 'SG'
    | 'SH'
    | 'SI'
    | 'SJ'
    | 'SK'
    | 'SL'
    | 'SM'
    | 'SN'
    | 'SO'
    | 'SR'
    | 'SS'
    | 'ST'
    | 'SV'
    | 'SX'
    | 'SY'
    | 'SZ'
    | 'TA'
    | 'TC'
    | 'TD'
    | 'TG'
    | 'TH'
    | 'TJ'
    | 'TK'
    | 'TL'
    | 'TM'
    | 'TN'
    | 'TO'
    | 'TR'
    | 'TT'
    | 'TV'
    | 'TW'
    | 'TZ'
    | 'UA'
    | 'UG'
    | 'US'
    | 'UY'
    | 'UZ'
    | 'VA'
    | 'VC'
    | 'VE'
    | 'VG'
    | 'VI'
    | 'VN'
    | 'VU'
    | 'WF'
    | 'WS'
    | 'XK'
    | 'YE'
    | 'YT'
    | 'ZA'
    | 'ZM'
    | 'ZW'
    | 'BV'
    | 'FX'
    | 'PN'
    | 'KV'
    | 'YU'
    | ''
  area_code: string
  domain_suffix: string
  latlng: {
    lat: number
    lng: number
  }
}

const coutryBase: CountryBase[] = [
  {
    id: 1,
    en_name: 'Aland Islands',
    zh_name: '奥兰群岛',
    code: 'AX',
    area_code: '358',
    domain_suffix: '.ax',
    latlng: {lat: 60.1785247, lng: 19.9156105}
  },
  {
    id: 2,
    en_name: 'Albania',
    zh_name: '阿尔巴尼亚',
    code: 'AL',
    area_code: '355',
    domain_suffix: '.al',
    latlng: {lat: 41.153332, lng: 20.168331}
  },
  {
    id: 3,
    en_name: 'Algeria',
    zh_name: '阿尔及利亚',
    code: 'DZ',
    area_code: '213',
    domain_suffix: '.dz',
    latlng: {lat: 28.033886, lng: 1.659626}
  },
  {
    id: 4,
    en_name: 'American Samoa',
    zh_name: '美属萨摩亚',
    code: 'AS',
    area_code: '685',
    domain_suffix: '',
    latlng: {lat: -14.270972, lng: -170.132217}
  },
  {
    id: 5,
    en_name: 'Andorra',
    zh_name: '安道尔',
    code: 'AD',
    area_code: '376',
    domain_suffix: '.ad',
    latlng: {lat: 42.506285, lng: 1.521801}
  },
  {
    id: 6,
    en_name: 'Angola',
    zh_name: '安哥拉',
    code: 'AO',
    area_code: '244',
    domain_suffix: '.ao',
    latlng: {lat: -11.202692, lng: 17.873887}
  },
  {
    id: 7,
    en_name: 'Anguilla',
    zh_name: '安圭拉',
    code: 'AI',
    area_code: '1264',
    domain_suffix: '.ai',
    latlng: {lat: 18.220554, lng: -63.068615}
  },
  {
    id: 8,
    en_name: 'Antigua and Barbuda',
    zh_name: '安提瓜和巴布达',
    code: 'AG',
    area_code: '1268',
    domain_suffix: '.ag',
    latlng: {lat: 17.060816, lng: -61.796428}
  },
  {
    id: 9,
    en_name: 'Argentina',
    zh_name: '阿根廷',
    code: 'AR',
    area_code: '54',
    domain_suffix: '.ar',
    latlng: {lat: -38.416097, lng: -63.616672}
  },
  {
    id: 10,
    en_name: 'Armenia',
    zh_name: '亚美尼亚',
    code: 'AM',
    area_code: '374',
    domain_suffix: '.am',
    latlng: {lat: 40.069099, lng: 45.038189}
  },
  {
    id: 11,
    en_name: 'Aruba',
    zh_name: '阿鲁巴',
    code: 'AW',
    area_code: '297',
    domain_suffix: '.aw',
    latlng: {lat: 12.52111, lng: -69.968338}
  },
  {
    id: 12,
    en_name: 'Australia',
    zh_name: '澳大利亚',
    code: 'AU',
    area_code: '61',
    domain_suffix: '.au',
    latlng: {lat: -25.274398, lng: 133.775136}
  },
  {
    id: 13,
    en_name: 'Austria',
    zh_name: '奥地利',
    code: 'AT',
    area_code: '43',
    domain_suffix: '.at',
    latlng: {lat: 47.516231, lng: 14.550072}
  },
  {
    id: 14,
    en_name: 'Azerbaijan',
    zh_name: '阿塞拜疆',
    code: 'AZ',
    area_code: '994',
    domain_suffix: '.az',
    latlng: {lat: 40.143105, lng: 47.576927}
  },
  {
    id: 15,
    keywords: ['Bengal'],
    en_name: 'Bangladesh',
    zh_name: '孟加拉',
    code: 'BD',
    area_code: '880',
    domain_suffix: '.bd',
    latlng: {lat: 23.684994, lng: 90.356331}
  },
  {
    id: 16,
    en_name: 'Bahrain',
    zh_name: '巴林',
    code: 'BH',
    area_code: '973',
    domain_suffix: '.bh',
    latlng: {lat: 26.0667, lng: 50.5577}
  },
  {
    id: 17,
    en_name: 'Bahamas',
    zh_name: '巴哈马',
    code: 'BS',
    area_code: '1242',
    domain_suffix: '.bs',
    latlng: {lat: 25.03428, lng: -77.39628}
  },
  {
    id: 18,
    en_name: 'Barbados',
    zh_name: '巴巴多斯',
    code: 'BB',
    area_code: '1246',
    domain_suffix: '.bb',
    latlng: {lat: 13.193887, lng: -59.543198}
  },
  {
    id: 19,
    en_name: 'Belarus',
    zh_name: '白俄罗斯',
    code: 'BY',
    area_code: '375',
    domain_suffix: '.by',
    latlng: {lat: 53.709807, lng: 27.953389}
  },
  {
    id: 20,
    en_name: 'Belgium',
    zh_name: '比利时',
    code: 'BE',
    area_code: '32',
    domain_suffix: '.be',
    latlng: {lat: 50.503887, lng: 4.469936}
  },
  {
    id: 21,
    en_name: 'Belize',
    zh_name: '伯利兹',
    code: 'BZ',
    area_code: '501',
    domain_suffix: '.bz',
    latlng: {lat: 17.189877, lng: -88.49765}
  },
  {
    id: 22,
    en_name: 'Benin',
    zh_name: '贝宁',
    code: 'BJ',
    area_code: '229',
    domain_suffix: '.bj',
    latlng: {lat: 9.30769, lng: 2.315834}
  },
  {
    id: 23,
    en_name: 'Bermuda',
    zh_name: '百慕大',
    code: 'BM',
    area_code: '1441',
    domain_suffix: '.bm',
    latlng: {lat: 32.3078, lng: -64.7505}
  },
  {
    id: 24,
    en_name: 'Bhutan',
    zh_name: '不丹',
    code: 'BT',
    area_code: '975',
    domain_suffix: '.bt',
    latlng: {lat: 27.514162, lng: 90.433601}
  },
  {
    id: 25,
    en_name: 'Bolivia',
    zh_name: '玻利维亚',
    code: 'BO',
    area_code: '591',
    domain_suffix: '.bo',
    latlng: {lat: -16.290154, lng: -63.588653}
  },
  {
    id: 26,
    en_name: 'Bosnia and Herzegovina',
    keywords: ['Bosnia', 'Herzegovina'],
    zh_name: '波斯尼亚和黑塞哥维那',
    code: 'BA',
    area_code: '387',
    domain_suffix: '.ba',
    latlng: {lat: 43.915886, lng: 17.679076}
  },
  {
    id: 27,
    en_name: 'Botswana',
    zh_name: '博茨瓦纳',
    code: 'BW',
    area_code: '267',
    domain_suffix: '.bw',
    latlng: {lat: -22.328474, lng: 24.684866}
  },
  {
    id: 28,
    en_name: 'Bouvet Island',
    zh_name: '布维岛',
    code: 'BV',
    area_code: '',
    domain_suffix: '.bv',
    latlng: {lat: -54.4207915, lng: 3.3464497}
  },
  {
    id: 29,
    en_name: 'Brazil',
    zh_name: '巴西',
    code: 'BR',
    area_code: '55',
    domain_suffix: '.br',
    latlng: {lat: -14.235004, lng: -51.92528}
  },
  {
    id: 30,
    en_name: 'Brunei',
    zh_name: '文莱',
    code: 'BN',
    area_code: '673',
    domain_suffix: '.bn',
    latlng: {lat: 4.535277, lng: 114.727669}
  },
  {
    id: 31,
    en_name: 'Bulgaria',
    zh_name: '保加利亚',
    code: 'BG',
    area_code: '359',
    domain_suffix: '.bg',
    latlng: {lat: 42.733883, lng: 25.48583}
  },
  {
    id: 32,
    en_name: 'Burkina Faso',
    zh_name: '布基纳法索',
    code: 'BF',
    area_code: '226',
    domain_suffix: '.bf',
    latlng: {lat: 12.238333, lng: -1.561593}
  },
  {
    id: 33,
    en_name: 'Burundi',
    zh_name: '布隆迪',
    code: 'BI',
    area_code: '257',
    domain_suffix: '.bi',
    latlng: {lat: -3.373056, lng: 29.918886}
  },
  {
    id: 34,
    keywords: ['phnom penh'],
    en_name: 'Cambodia',
    zh_name: '柬埔寨',
    code: 'KH',
    area_code: '855',
    domain_suffix: '.kh',
    latlng: {lat: 12.565679, lng: 104.990963}
  },
  {
    id: 35,
    en_name: 'Cameroon',
    zh_name: '喀麦隆',
    code: 'CM',
    area_code: '237',
    domain_suffix: '.cm',
    latlng: {lat: 7.369722, lng: 12.354722}
  },
  {
    id: 218,
    keywords: ['U.S.'],
    en_name: 'United States',
    zh_name: '美国',
    code: 'US',
    area_code: '1',
    domain_suffix: '.us',
    latlng: {lat: 37.09024, lng: -95.712891}
  },
  {
    id: 36,
    en_name: 'Canada',
    zh_name: '加拿大',
    code: 'CA',
    area_code: '1',
    domain_suffix: '.ca',
    latlng: {lat: 56.130366, lng: -106.346771}
  },
  {
    id: 37,
    en_name: 'Cape Verde',
    zh_name: '佛得角',
    code: 'CV',
    area_code: '238',
    domain_suffix: '.cv',
    latlng: {lat: 16.5388, lng: -23.0418}
  },
  {
    id: 38,
    keywords: ['Central Africa'],
    en_name: 'Central African Republic',
    zh_name: '中非',
    code: 'CF',
    area_code: '236',
    domain_suffix: '.cf',
    latlng: {lat: 6.611111, lng: 20.939444}
  },
  {
    id: 39,
    en_name: 'Chad',
    zh_name: '乍得',
    code: 'TD',
    area_code: '235',
    domain_suffix: '.td',
    latlng: {lat: 15.454166, lng: 18.732207}
  },
  {
    id: 40,
    en_name: 'Chile',
    zh_name: '智利',
    code: 'CL',
    area_code: '56',
    domain_suffix: '.cl',
    latlng: {lat: -35.675147, lng: -71.542969}
  },
  {
    id: 41,
    en_name: 'Christmas Islands',
    zh_name: '圣诞岛',
    code: 'CX',
    area_code: '61',
    domain_suffix: '.cx',
    latlng: {lat: -10.447525, lng: 105.690449}
  },
  {
    id: 42,
    keywords: ['Cocos', 'keeling'],
    en_name: 'Cocos (keeling) Islands',
    zh_name: '科科斯（基林）群岛',
    code: 'CC',
    area_code: '61',
    domain_suffix: '.cc',
    latlng: {lat: -12.164165, lng: 96.870956}
  },
  {
    id: 43,
    en_name: 'Colombia',
    zh_name: '哥伦比亚',
    code: 'CO',
    area_code: '57',
    domain_suffix: '.co',
    latlng: {lat: 4.570868, lng: -74.297333}
  },
  {
    id: 44,
    en_name: 'Comoros',
    zh_name: '科摩罗',
    code: 'KM',
    area_code: '269',
    domain_suffix: '.km',
    latlng: {lat: -11.6455, lng: 43.3333}
  },
  {
    id: 45,
    keywords: ['Democratic Republic of Congo', 'DRC', 'Congo-Kinshasa'],
    en_name: 'Congo (Congo-Kinshasa)',
    zh_name: '刚果（金）',
    code: 'CD',
    area_code: '243',
    domain_suffix: '.cd',
    latlng: {lat: -4.038333, lng: 21.758664}
  },
  {
    id: 46,
    keywords: ['Republic of the Congo', 'COG'],
    en_name: 'Congo',
    zh_name: '刚果',
    code: 'CG',
    area_code: '242',
    domain_suffix: '.cg',
    latlng: {lat: -0.228021, lng: 15.827659}
  },
  {
    id: 47,
    en_name: 'Cook Islands',
    zh_name: '库克群岛',
    code: 'CK',
    area_code: '682',
    domain_suffix: '.ck',
    latlng: {lat: -21.236736, lng: -159.777671}
  },
  {
    id: 48,
    en_name: 'Costa Rica',
    zh_name: '哥斯达黎加',
    code: 'CR',
    area_code: '506',
    domain_suffix: '.cr',
    latlng: {lat: 9.748917, lng: -83.753428}
  },
  {
    id: 49,
    keywords: ["Côte d'Ivoire"],
    en_name: "Cote D'Ivoire",
    zh_name: '科特迪瓦',
    code: 'CI',
    area_code: '225',
    domain_suffix: '.ci',
    latlng: {lat: 7.539989, lng: -5.54708}
  },
  {
    id: 50,
    en_name: 'China',
    zh_name: '中国',
    code: 'CN',
    area_code: '86',
    domain_suffix: '.cn',
    latlng: {lat: 35.86166, lng: 104.195397}
  },
  {
    id: 51,
    en_name: 'Croatia',
    zh_name: '克罗地亚',
    code: 'HR',
    area_code: '385',
    domain_suffix: '.hr',
    latlng: {lat: 45.1, lng: 15.2000001}
  },
  {
    id: 52,
    en_name: 'Cuba',
    zh_name: '古巴',
    code: 'CU',
    area_code: '53',
    domain_suffix: '.cu',
    latlng: {lat: 21.521757, lng: -77.781167}
  },
  {
    id: 53,
    en_name: 'Czech',
    zh_name: '捷克',
    code: 'CZ',
    area_code: '420',
    domain_suffix: '.cz',
    latlng: {lat: 49.817492, lng: 15.472962}
  },
  {
    id: 54,
    en_name: 'Cyprus',
    zh_name: '塞浦路斯',
    code: 'CY',
    area_code: '357',
    domain_suffix: '.cy',
    latlng: {lat: 35.126413, lng: 33.429859}
  },
  {
    id: 55,
    en_name: 'Denmark',
    zh_name: '丹麦',
    code: 'DK',
    area_code: '45',
    domain_suffix: '.dk',
    latlng: {lat: 56.26392, lng: 9.501785}
  },
  {
    id: 56,
    en_name: 'Djibouti',
    zh_name: '吉布提',
    code: 'DJ',
    area_code: '253',
    domain_suffix: '.dj',
    latlng: {lat: 11.825138, lng: 42.590275}
  },
  {
    id: 57,
    en_name: 'Dominica',
    zh_name: '多米尼加',
    code: 'DO',
    area_code: '1767',
    domain_suffix: '.do',
    latlng: {lat: 15.414999, lng: -61.370976}
  },
  {
    id: 58,
    en_name: 'East Timor',
    zh_name: '东帝汶',
    code: 'TL',
    area_code: '670',
    domain_suffix: '.tl',
    latlng: {lat: -8.874217, lng: 125.727539}
  },
  {
    id: 59,
    en_name: 'Ecuador',
    zh_name: '厄瓜多尔',
    code: 'EC',
    area_code: '593',
    domain_suffix: '.ec',
    latlng: {lat: -1.831239, lng: -78.183406}
  },
  {
    id: 60,
    en_name: 'Egypt',
    zh_name: '埃及',
    code: 'EG',
    area_code: '20',
    domain_suffix: '.eg',
    latlng: {lat: 26.820553, lng: 30.802498}
  },
  {
    id: 61,
    en_name: 'Equatorial Guinea',
    zh_name: '赤道几内亚',
    code: 'GQ',
    area_code: '240',
    domain_suffix: '.gq',
    latlng: {lat: 1.650801, lng: 10.267895}
  },
  {
    id: 62,
    en_name: 'Eritrea',
    zh_name: '厄立特里亚',
    code: 'ER',
    area_code: '291',
    domain_suffix: '.er',
    latlng: {lat: 15.179384, lng: 39.782334}
  },
  {
    id: 63,
    en_name: 'Estonia',
    zh_name: '爱沙尼亚',
    code: 'EE',
    area_code: '372',
    domain_suffix: '.ee',
    latlng: {lat: 58.595272, lng: 25.0136071}
  },
  {
    id: 64,
    en_name: 'Ethiopia',
    zh_name: '埃塞俄比亚',
    code: 'ET',
    area_code: '251',
    domain_suffix: '.et',
    latlng: {lat: 9.145, lng: 40.489673}
  },
  {
    id: 65,
    en_name: 'Faroe Islands',
    zh_name: '法罗群岛',
    code: 'FO',
    area_code: '298',
    domain_suffix: '.fo',
    latlng: {lat: 61.892635, lng: -6.9118061}
  },
  {
    id: 66,
    en_name: 'Fiji',
    zh_name: '斐济',
    code: 'FJ',
    area_code: '679',
    domain_suffix: '.fj',
    latlng: {lat: -17.713371, lng: 178.065032}
  },
  {
    id: 67,
    en_name: 'Finland',
    zh_name: '芬兰',
    code: 'FI',
    area_code: '358',
    domain_suffix: '.fi',
    latlng: {lat: 61.92411, lng: 25.7481511}
  },
  {
    id: 68,
    en_name: 'France',
    zh_name: '法国',
    code: 'FR',
    area_code: '33',
    domain_suffix: '.fr',
    latlng: {lat: 46.227638, lng: 2.213749}
  },
  {
    id: 69,
    en_name: 'Franch Metropolitan',
    zh_name: '法国大都会',
    code: 'FX',
    area_code: '33',
    domain_suffix: '',
    latlng: {lat: 43.6599241, lng: 7.1946716}
  },
  {
    id: 70,
    en_name: 'Franch Guiana',
    zh_name: '法属圭亚那',
    code: 'GF',
    area_code: '594',
    domain_suffix: '',
    latlng: {lat: 3.933889, lng: -53.125782}
  },
  {
    id: 71,
    en_name: 'French Polynesia',
    zh_name: '法属波利尼西亚',
    code: 'PF',
    area_code: '689',
    domain_suffix: '.pf',
    latlng: {lat: -17.679742, lng: -149.406843}
  },
  {
    id: 72,
    en_name: 'Gabon',
    zh_name: '加蓬',
    code: 'GA',
    area_code: '241',
    domain_suffix: '.ga',
    latlng: {lat: -0.803689, lng: 11.609444}
  },
  {
    id: 73,
    en_name: 'Gambia',
    zh_name: '冈比亚',
    code: 'GM',
    area_code: '220',
    domain_suffix: '.gm',
    latlng: {lat: 13.443182, lng: -15.310139}
  },
  {
    id: 74,
    en_name: 'Georgia',
    zh_name: '格鲁吉亚',
    code: 'GE',
    area_code: '995',
    domain_suffix: '.ge',
    latlng: {lat: 42.315407, lng: 43.356892}
  },
  {
    id: 75,
    en_name: 'Germany',
    zh_name: '德国',
    code: 'DE',
    area_code: '49',
    domain_suffix: '.de',
    latlng: {lat: 51.165691, lng: 10.451526}
  },
  {
    id: 76,
    en_name: 'Ghana',
    zh_name: '加纳',
    code: 'GH',
    area_code: '233',
    domain_suffix: '.gh',
    latlng: {lat: 7.946527, lng: -1.023194}
  },
  {
    id: 77,
    en_name: 'Gibraltar',
    zh_name: '直布罗陀',
    code: 'GI',
    area_code: '350',
    domain_suffix: '.gi',
    latlng: {lat: 36.140751, lng: -5.353585}
  },
  {
    id: 78,
    en_name: 'Greece',
    zh_name: '希腊',
    code: 'GR',
    area_code: '30',
    domain_suffix: '.gr',
    latlng: {lat: 39.074208, lng: 21.824312}
  },
  {
    id: 79,
    en_name: 'Grenada',
    zh_name: '格林纳达',
    code: 'GD',
    area_code: '1473',
    domain_suffix: '.gd',
    latlng: {lat: 12.1165, lng: -61.679}
  },
  {
    id: 80,
    en_name: 'Guadeloupe',
    zh_name: '瓜德罗普岛',
    code: 'GP',
    area_code: '590',
    domain_suffix: '',
    latlng: {lat: 16.265, lng: -61.551}
  },
  {
    id: 81,
    en_name: 'Guam',
    zh_name: '关岛',
    code: 'GU',
    area_code: '1671',
    domain_suffix: '.gu',
    latlng: {lat: 13.444304, lng: 144.793731}
  },
  {
    id: 82,
    en_name: 'Guatemala',
    zh_name: '危地马拉',
    code: 'GT',
    area_code: '502',
    domain_suffix: '.gt',
    latlng: {lat: 15.783471, lng: -90.230759}
  },
  {
    id: 83,
    en_name: 'Guernsey',
    zh_name: '根西岛',
    code: 'GG',
    area_code: '441481',
    domain_suffix: '.gg',
    latlng: {lat: 49.4481982, lng: -2.58949}
  },
  {
    id: 84,
    en_name: 'Guinea-Bissau',
    zh_name: '几内亚比绍',
    code: 'GW',
    area_code: '245',
    domain_suffix: '.gw',
    latlng: {lat: 11.803749, lng: -15.180413}
  },
  {
    id: 85,
    en_name: 'Guinea',
    zh_name: '几内亚',
    code: 'GN',
    area_code: '224',
    domain_suffix: '.gn',
    latlng: {lat: 9.945587, lng: -9.696645}
  },
  {
    id: 86,
    en_name: 'Guyana',
    zh_name: '圭亚那',
    code: 'GY',
    area_code: '592',
    domain_suffix: '.gy',
    latlng: {lat: 4.860416, lng: -58.93018}
  },
  {
    id: 87,
    keywords: ['Hong Kong (China)', '香港'],
    en_name: 'Hong Kong',
    zh_name: '香港 (中国)',
    code: 'HK',
    area_code: '852',
    domain_suffix: '',
    latlng: {lat: 22.3193039, lng: 114.1693611}
  },
  {
    id: 88,
    en_name: 'Haiti',
    zh_name: '海地',
    code: 'HT',
    area_code: '509',
    domain_suffix: '.ht',
    latlng: {lat: 18.971187, lng: -72.285215}
  },
  {
    id: 89,
    en_name: 'Honduras',
    zh_name: '洪都拉斯',
    code: 'HN',
    area_code: '504',
    domain_suffix: '.hn',
    latlng: {lat: 15.199999, lng: -86.241905}
  },
  {
    id: 90,
    en_name: 'Hungary',
    zh_name: '匈牙利',
    code: 'HU',
    area_code: '36',
    domain_suffix: '.hu',
    latlng: {lat: 47.162494, lng: 19.5033041}
  },
  {
    id: 91,
    en_name: 'Iceland',
    zh_name: '冰岛',
    code: 'IS',
    area_code: '354',
    domain_suffix: '.is',
    latlng: {lat: 64.963051, lng: -19.020835}
  },
  {
    id: 92,
    en_name: 'India',
    zh_name: '印度',
    code: 'IN',
    area_code: '91',
    domain_suffix: '.in',
    latlng: {lat: 20.593684, lng: 78.96288}
  },
  {
    id: 93,
    en_name: 'Indonesia',
    zh_name: '印度尼西亚',
    code: 'ID',
    area_code: '62',
    domain_suffix: '.id',
    latlng: {lat: -0.789275, lng: 113.921327}
  },
  {
    id: 94,
    en_name: 'Iran',
    zh_name: '伊朗',
    code: 'IR',
    area_code: '98',
    domain_suffix: '.ir',
    latlng: {lat: 32.427908, lng: 53.688046}
  },
  {
    id: 95,
    en_name: 'Iraq',
    zh_name: '伊拉克',
    code: 'IQ',
    area_code: '964',
    domain_suffix: '.iq',
    latlng: {lat: 33.223191, lng: 43.679291}
  },
  {
    id: 96,
    en_name: 'Ireland',
    zh_name: '爱尔兰',
    code: 'IE',
    area_code: '353',
    domain_suffix: '.ie',
    latlng: {lat: 53.41291, lng: -8.24389}
  },
  {
    id: 97,
    en_name: 'Isle of Man',
    zh_name: '马恩岛',
    code: 'IM',
    area_code: '441624',
    domain_suffix: '.im',
    latlng: {lat: 54.236107, lng: -4.548056}
  },
  {
    id: 98,
    en_name: 'Israel',
    zh_name: '以色列',
    code: 'IL',
    area_code: '972',
    domain_suffix: '.il',
    latlng: {lat: 31.046051, lng: 34.851612}
  },
  {
    id: 99,
    en_name: 'Italy',
    zh_name: '意大利',
    code: 'IT',
    area_code: '39',
    domain_suffix: '.it',
    latlng: {lat: 41.87194, lng: 12.56738}
  },
  {
    id: 100,
    en_name: 'Jamaica',
    zh_name: '牙买加',
    code: 'JM',
    area_code: '1876',
    domain_suffix: '.jm',
    latlng: {lat: 18.109581, lng: -77.297508}
  },
  {
    id: 101,
    en_name: 'Japan',
    zh_name: '日本',
    code: 'JP',
    area_code: '81',
    domain_suffix: '.jp',
    latlng: {lat: 36.204824, lng: 138.252924}
  },
  {
    id: 102,
    en_name: 'Jersey',
    zh_name: '泽西岛',
    code: 'JE',
    area_code: '44',
    domain_suffix: '.je',
    latlng: {lat: 49.214439, lng: -2.13125}
  },
  {
    id: 103,
    en_name: 'Jordan',
    zh_name: '约旦',
    code: 'JO',
    area_code: '962',
    domain_suffix: '.jo',
    latlng: {lat: 30.585164, lng: 36.238414}
  },
  {
    id: 104,
    en_name: 'Kazakhstan',
    zh_name: '哈萨克斯坦',
    code: 'KZ',
    area_code: '7',
    domain_suffix: '.kz',
    latlng: {lat: 48.019573, lng: 66.923684}
  },
  {
    id: 105,
    en_name: 'Kenya',
    zh_name: '肯尼亚',
    code: 'KE',
    area_code: '254',
    domain_suffix: '.ke',
    latlng: {lat: -0.023559, lng: 37.906193}
  },
  {
    id: 106,
    en_name: 'Kiribati',
    zh_name: '基里巴斯',
    code: 'KI',
    area_code: '686',
    domain_suffix: '.kir',
    latlng: {lat: -3.370417, lng: -168.734039}
  },
  {
    id: 107,
    en_name: 'South Korea',
    zh_name: '韩国',
    code: 'KR',
    area_code: '82',
    domain_suffix: '.kr',
    latlng: {lat: 35.907757, lng: 127.766922}
  },
  {
    id: 108,
    en_name: 'North Korea',
    zh_name: '朝鲜',
    code: 'KP',
    area_code: '850',
    domain_suffix: '.kp',
    latlng: {lat: 40.339852, lng: 127.510093}
  },
  {
    id: 109,
    en_name: 'Kuwait',
    zh_name: '科威特',
    code: 'KW',
    area_code: '965',
    domain_suffix: '.kw',
    latlng: {lat: 29.31166, lng: 47.481766}
  },
  {
    id: 110,
    en_name: 'Kyrgyzstan',
    zh_name: '吉尔吉斯斯坦',
    code: 'KG',
    area_code: '996',
    domain_suffix: '.kg',
    latlng: {lat: 41.20438, lng: 74.766098}
  },
  {
    id: 111,
    en_name: 'Laos',
    zh_name: '老挝',
    code: 'LA',
    area_code: '856',
    domain_suffix: '.la',
    latlng: {lat: 19.85627, lng: 102.495496}
  },
  {
    id: 112,
    en_name: 'Latvia',
    zh_name: '拉脱维亚',
    code: 'LV',
    area_code: '371',
    domain_suffix: '.lv',
    latlng: {lat: 56.879635, lng: 24.603189}
  },
  {
    id: 113,
    en_name: 'Lebanon',
    zh_name: '黎巴嫩',
    code: 'LB',
    area_code: '961',
    domain_suffix: '.lb',
    latlng: {lat: 33.854721, lng: 35.862285}
  },
  {
    id: 114,
    en_name: 'Lesotho',
    zh_name: '莱索托',
    code: 'LS',
    area_code: '266',
    domain_suffix: '.ls',
    latlng: {lat: -29.609988, lng: 28.233608}
  },
  {
    id: 115,
    en_name: 'Liberia',
    zh_name: '利比里亚',
    code: 'LR',
    area_code: '231',
    domain_suffix: '.lr',
    latlng: {lat: 6.428055, lng: -9.429499}
  },
  {
    id: 116,
    en_name: 'Libya',
    zh_name: '利比亚',
    code: 'LY',
    area_code: '218',
    domain_suffix: '.ly',
    latlng: {lat: 26.3351, lng: 17.228331}
  },
  {
    id: 117,
    en_name: 'Liechtenstein',
    zh_name: '列支敦士登',
    code: 'LI',
    area_code: '423',
    domain_suffix: '.li',
    latlng: {lat: 47.166, lng: 9.555373}
  },
  {
    id: 118,
    en_name: 'Lithuania',
    zh_name: '立陶宛',
    code: 'LT',
    area_code: '370',
    domain_suffix: '.lt',
    latlng: {lat: 55.169438, lng: 23.881275}
  },
  {
    id: 119,
    en_name: 'Luxembourg',
    zh_name: '卢森堡',
    code: 'LU',
    area_code: '352',
    domain_suffix: '.lu',
    latlng: {lat: 49.815273, lng: 6.129583}
  },
  {
    id: 120,
    keywords: ['Macau (China)', '澳门'],
    en_name: 'Macau',
    zh_name: '澳门（中国）',
    code: 'MO',
    area_code: '853',
    domain_suffix: '.mo',
    latlng: {lat: 22.198745, lng: 113.543873}
  },
  {
    id: 121,
    en_name: 'Macedonia',
    zh_name: '马其顿',
    code: 'MK',
    area_code: '389',
    domain_suffix: '.mk',
    latlng: {lat: 41.608635, lng: 21.745275}
  },
  {
    id: 122,
    en_name: 'Malawi',
    zh_name: '马拉维',
    code: 'MW',
    area_code: '265',
    domain_suffix: '.mw',
    latlng: {lat: -13.254308, lng: 34.301525}
  },
  {
    id: 123,
    en_name: 'Malaysia',
    zh_name: '马来西亚',
    code: 'MY',
    area_code: '60',
    domain_suffix: '.my',
    latlng: {lat: 4.210484, lng: 101.975766}
  },
  {
    id: 124,
    en_name: 'Madagascar',
    zh_name: '马达加斯加',
    code: 'MG',
    area_code: '261',
    domain_suffix: '.mg',
    latlng: {lat: -18.766947, lng: 46.869107}
  },
  {
    id: 125,
    en_name: 'Maldives',
    zh_name: '马尔代夫',
    code: 'MV',
    area_code: '960',
    domain_suffix: '.mv',
    latlng: {lat: 3.202778, lng: 73.22068}
  },
  {
    id: 126,
    en_name: 'Mali',
    zh_name: '马里',
    code: 'ML',
    area_code: '223',
    domain_suffix: '.ml',
    latlng: {lat: 17.570692, lng: -3.996166}
  },
  {
    id: 127,
    en_name: 'Malta',
    zh_name: '马耳他',
    code: 'MT',
    area_code: '356',
    domain_suffix: '.mt',
    latlng: {lat: 35.937496, lng: 14.375416}
  },
  {
    id: 128,
    en_name: 'Marshall Islands',
    zh_name: '马绍尔群岛',
    code: 'MH',
    area_code: '692',
    domain_suffix: '.mh',
    latlng: {lat: 7.131474, lng: 171.184478}
  },
  {
    id: 129,
    en_name: 'Martinique',
    zh_name: '马提尼克岛',
    code: 'MQ',
    area_code: '596',
    domain_suffix: '',
    latlng: {lat: 14.641528, lng: -61.024174}
  },
  {
    id: 130,
    en_name: 'Mauritania',
    zh_name: '毛里塔尼亚',
    code: 'MR',
    area_code: '222',
    domain_suffix: '.mr',
    latlng: {lat: 21.00789, lng: -10.940835}
  },
  {
    id: 131,
    en_name: 'Mauritius',
    zh_name: '毛里求斯',
    code: 'MU',
    area_code: '230',
    domain_suffix: '.mu',
    latlng: {lat: -20.348404, lng: 57.552152}
  },
  {
    id: 132,
    en_name: 'Mayotte',
    zh_name: '马约特',
    code: 'YT',
    area_code: '269',
    domain_suffix: '.yt',
    latlng: {lat: -12.8275, lng: 45.166244}
  },
  {
    id: 133,
    en_name: 'Mexico',
    zh_name: '墨西哥',
    code: 'MX',
    area_code: '52',
    domain_suffix: '.mx',
    latlng: {lat: 23.634501, lng: -102.552784}
  },
  {
    id: 134,
    en_name: 'Micronesia',
    zh_name: '密克罗尼西亚',
    code: 'MF',
    area_code: '691',
    domain_suffix: '',
    latlng: {lat: 7.425554, lng: 150.550812}
  },
  {
    id: 135,
    en_name: 'Moldova',
    zh_name: '摩尔多瓦',
    code: 'MD',
    area_code: '373',
    domain_suffix: '.md',
    latlng: {lat: 47.411631, lng: 28.369885}
  },
  {
    id: 136,
    en_name: 'Monaco',
    zh_name: '摩纳哥',
    code: 'MC',
    area_code: '377',
    domain_suffix: '.mc',
    latlng: {lat: 43.7384176, lng: 7.4246158}
  },
  {
    id: 137,
    en_name: 'Mongolia',
    zh_name: '蒙古',
    code: 'MN',
    area_code: '976',
    domain_suffix: '.mn',
    latlng: {lat: 46.862496, lng: 103.846656}
  },
  {
    id: 138,
    en_name: 'Montenegro',
    zh_name: '黑山',
    code: 'ME',
    area_code: '382',
    domain_suffix: '.me',
    latlng: {lat: 42.708678, lng: 19.37439}
  },
  {
    id: 139,
    en_name: 'Montserrat',
    zh_name: '蒙特塞拉特',
    code: 'MS',
    area_code: '1664',
    domain_suffix: '.ms',
    latlng: {lat: 16.742498, lng: -62.187366}
  },
  {
    id: 140,
    en_name: 'Morocco',
    zh_name: '摩洛哥',
    code: 'MA',
    area_code: '212',
    domain_suffix: '.ma',
    latlng: {lat: 31.791702, lng: -7.09262}
  },
  {
    id: 141,
    en_name: 'Mozambique',
    zh_name: '莫桑比克',
    code: 'MZ',
    area_code: '258',
    domain_suffix: '.mz',
    latlng: {lat: -18.665695, lng: 35.529562}
  },
  {
    id: 142,
    en_name: 'Myanmar',
    zh_name: '缅甸',
    code: 'MM',
    area_code: '95',
    domain_suffix: '.mm',
    latlng: {lat: 21.916221, lng: 95.955974}
  },
  {
    id: 143,
    en_name: 'Namibia',
    zh_name: '纳米比亚',
    code: 'NA',
    area_code: '264',
    domain_suffix: '.na',
    latlng: {lat: -22.95764, lng: 18.49041}
  },
  {
    id: 144,
    en_name: 'Nauru',
    zh_name: '瑙鲁',
    code: 'NR',
    area_code: '674',
    domain_suffix: '.nr',
    latlng: {lat: -0.522778, lng: 166.931503}
  },
  {
    id: 145,
    en_name: 'Nepal',
    zh_name: '尼泊尔',
    code: 'NP',
    area_code: '977',
    domain_suffix: '.np',
    latlng: {lat: 28.394857, lng: 84.124008}
  },
  {
    id: 146,
    en_name: 'Netherlands',
    zh_name: '荷兰',
    code: 'NL',
    area_code: '31',
    domain_suffix: '.nl',
    latlng: {lat: 52.132633, lng: 5.291266}
  },
  {
    id: 147,
    en_name: 'New Caledonia',
    zh_name: '新喀里多尼亚',
    code: 'NC',
    area_code: '687',
    domain_suffix: '.nc',
    latlng: {lat: -20.904305, lng: 165.618042}
  },
  {
    id: 148,
    en_name: 'New Zealand',
    zh_name: '新西兰',
    code: 'NZ',
    area_code: '64',
    domain_suffix: '.nz',
    latlng: {lat: -40.900557, lng: 174.885971}
  },
  {
    id: 149,
    en_name: 'Nicaragua',
    zh_name: '尼加拉瓜',
    code: 'NI',
    area_code: '505',
    domain_suffix: '.ni',
    latlng: {lat: 12.865416, lng: -85.207229}
  },
  {
    id: 150,
    en_name: 'Niger',
    zh_name: '尼日尔',
    code: 'NE',
    area_code: '227',
    domain_suffix: '.ne',
    latlng: {lat: 17.607789, lng: 8.081666}
  },
  {
    id: 151,
    en_name: 'Nigeria',
    zh_name: '尼日利亚',
    code: 'NG',
    area_code: '234',
    domain_suffix: '.ng',
    latlng: {lat: 9.081999, lng: 8.675277}
  },
  {
    id: 152,
    en_name: 'Niue',
    zh_name: '纽埃',
    code: 'NU',
    area_code: '683',
    domain_suffix: '.nu',
    latlng: {lat: -19.054445, lng: -169.867233}
  },
  {
    id: 153,
    keywords: ['Norfolk'],
    en_name: 'Norfolk Island',
    zh_name: '诺福克岛',
    code: 'NF',
    area_code: '672',
    domain_suffix: '.nf',
    latlng: {lat: -29.040835, lng: 167.954712}
  },
  {
    id: 154,
    en_name: 'Norway',
    zh_name: '挪威',
    code: 'NO',
    area_code: '47',
    domain_suffix: '.no',
    latlng: {lat: 60.472024, lng: 8.468946}
  },
  {
    id: 155,
    en_name: 'Oman',
    zh_name: '阿曼',
    code: 'OM',
    area_code: '968',
    domain_suffix: '.om',
    latlng: {lat: 21.4735329, lng: 55.975413}
  },
  {
    id: 156,
    en_name: 'Pakistan',
    zh_name: '巴基斯坦',
    code: 'PK',
    area_code: '92',
    domain_suffix: '.pk',
    latlng: {lat: 30.375321, lng: 69.345116}
  },
  {
    id: 157,
    en_name: 'Palau',
    zh_name: '帕劳',
    code: 'PW',
    area_code: '680',
    domain_suffix: '.pw',
    latlng: {lat: 7.51498, lng: 134.58252}
  },
  {
    id: 158,
    en_name: 'Palestine',
    zh_name: '巴勒斯坦',
    code: 'PS',
    area_code: '970',
    domain_suffix: '.ps',
    latlng: {lat: 31.952162, lng: 35.233154}
  },
  {
    id: 159,
    en_name: 'Panama',
    zh_name: '巴拿马',
    code: 'PA',
    area_code: '507',
    domain_suffix: '.pa',
    latlng: {lat: 8.537981, lng: -80.782127}
  },
  {
    id: 160,
    en_name: 'Papua New Guinea',
    zh_name: '巴布亚新几内亚',
    code: 'PG',
    area_code: '675',
    domain_suffix: '.pg',
    latlng: {lat: -6.314993, lng: 143.95555}
  },
  {
    id: 161,
    en_name: 'Paraguay',
    zh_name: '巴拉圭',
    code: 'PY',
    area_code: '595',
    domain_suffix: '.py',
    latlng: {lat: -23.442503, lng: -58.443832}
  },
  {
    id: 162,
    en_name: 'Peru',
    zh_name: '秘鲁',
    code: 'PE',
    area_code: '51',
    domain_suffix: '.pe',
    latlng: {lat: -9.189967, lng: -75.015152}
  },
  {
    id: 163,
    keywords: ['the Philippines'],
    en_name: 'Philippines',
    zh_name: '菲律宾',
    code: 'PH',
    area_code: '63',
    domain_suffix: '.ph',
    latlng: {lat: 12.879721, lng: 121.774017}
  },
  {
    id: 164,
    keywords: ['Pitcairn'],
    en_name: 'Pitcairn Islands',
    zh_name: '皮特凯恩群岛',
    code: 'PN',
    area_code: '64',
    domain_suffix: '.pn',
    latlng: {lat: -24.3767537, lng: -128.3242376}
  },
  {
    id: 165,
    en_name: 'Poland',
    zh_name: '波兰',
    code: 'PL',
    area_code: '48',
    domain_suffix: '.pl',
    latlng: {lat: 51.919438, lng: 19.145136}
  },
  {
    id: 166,
    en_name: 'Portugal',
    zh_name: '葡萄牙',
    code: 'PT',
    area_code: '351',
    domain_suffix: '.pt',
    latlng: {lat: 39.399872, lng: -8.224454}
  },
  {
    id: 167,
    en_name: 'Puerto Rico',
    zh_name: '波多黎各',
    code: 'PR',
    area_code: '1787',
    domain_suffix: '.pr',
    latlng: {lat: 18.220833, lng: -66.590149}
  },
  {
    id: 168,
    en_name: 'Qatar',
    zh_name: '卡塔尔',
    code: 'QA',
    area_code: '974',
    domain_suffix: '.qa',
    latlng: {lat: 25.354826, lng: 51.183884}
  },
  {
    id: 169,
    keywords: ['Reunion Island'],
    en_name: 'Reunion',
    zh_name: '留尼汪岛',
    code: 'RE',
    area_code: '262',
    domain_suffix: '.re',
    latlng: {lat: -21.115141, lng: 55.536384}
  },
  {
    id: 170,
    en_name: 'Romania',
    zh_name: '罗马尼亚',
    code: 'RO',
    area_code: '40',
    domain_suffix: '.ro',
    latlng: {lat: 45.943161, lng: 24.96676}
  },
  {
    id: 171,
    en_name: 'Rwanda',
    zh_name: '卢旺达',
    code: 'RW',
    area_code: '250',
    domain_suffix: '.rw',
    latlng: {lat: -1.940278, lng: 29.873888}
  },
  {
    id: 172,
    keywords: ['russia', 'moscow'],
    en_name: 'Russian Federation',
    zh_name: '俄罗斯',
    code: 'RU',
    area_code: '7',
    domain_suffix: '.ru',
    latlng: {lat: 61.52401, lng: 105.318756}
  },
  {
    id: 173,
    keywords: ['St. Helena'],
    en_name: 'Saint Helena',
    zh_name: '圣赫勒拿',
    code: 'SH',
    area_code: '290',
    domain_suffix: '.sh',
    latlng: {lat: -15.9650104, lng: -5.7089241}
  },
  {
    id: 174,
    keywords: ['Saint Kitts and Nevis', 'Saint Kitts', 'Saint Kitts'],
    en_name: 'Saint Kitts-Nevis',
    zh_name: '圣基茨和尼维斯',
    code: 'KN',
    area_code: '1869',
    domain_suffix: '.kn',
    latlng: {lat: 17.357822, lng: -62.782998}
  },
  {
    id: 175,
    en_name: 'Saint Lucia',
    zh_name: '圣卢西亚',
    code: 'LC',
    area_code: '1758',
    domain_suffix: '.lc',
    latlng: {lat: 13.909444, lng: -60.978893}
  },
  {
    id: 176,
    keywords: ['Saint Vincent', 'Grenadines'],
    en_name: 'Saint Vincent and the Grenadines',
    zh_name: '圣文森特和格林纳丁斯',
    code: 'VG',
    area_code: '1284',
    domain_suffix: '.vc',
    latlng: {lat: 12.984305, lng: -61.287228}
  },
  {
    id: 177,
    keywords: ['salvador'],
    en_name: 'El Salvador',
    zh_name: '萨尔瓦多',
    code: 'SV',
    area_code: '503',
    domain_suffix: '.sv',
    latlng: {lat: 13.794185, lng: -88.89653}
  },
  {
    id: 178,
    en_name: 'Samoa',
    zh_name: '萨摩亚',
    code: 'WS',
    area_code: '684',
    domain_suffix: '.ws',
    latlng: {lat: -13.759029, lng: -172.104629}
  },
  {
    id: 179,
    en_name: 'San Marino',
    zh_name: '圣马力诺',
    code: 'SM',
    area_code: '378',
    domain_suffix: '.sm',
    latlng: {lat: 43.94236, lng: 12.457777}
  },
  {
    id: 180,
    keywords: ['Sao Tome', 'Principe'],
    en_name: 'Sao Tome and Principe',
    zh_name: '圣多美和普林西比',
    code: 'ST',
    area_code: '239',
    domain_suffix: '.st',
    latlng: {lat: 0.18636, lng: 6.613081}
  },
  {
    id: 181,
    en_name: 'Saudi Arabia',
    zh_name: '沙特阿拉伯',
    code: 'SA',
    area_code: '966',
    domain_suffix: '.sa',
    latlng: {lat: 23.885942, lng: 45.079162}
  },
  {
    id: 182,
    en_name: 'Senegal',
    zh_name: '塞内加尔',
    code: 'SN',
    area_code: '221',
    domain_suffix: '.sn',
    latlng: {lat: 14.497401, lng: -14.452362}
  },
  {
    id: 183,
    en_name: 'Seychelles',
    zh_name: '塞舌尔',
    code: 'SC',
    area_code: '248',
    domain_suffix: '.sc',
    latlng: {lat: -4.679574, lng: 55.491977}
  },
  {
    id: 184,
    en_name: 'Sierra Leone',
    zh_name: '塞拉利昂',
    code: 'SL',
    area_code: '232',
    domain_suffix: '.sl',
    latlng: {lat: 8.460555, lng: -11.779889}
  },
  {
    id: 185,
    en_name: 'Serbia',
    zh_name: '塞尔维亚',
    code: 'RS',
    area_code: '381',
    domain_suffix: '.rs',
    latlng: {lat: 44.016521, lng: 21.005859}
  },
  {
    id: 186,
    en_name: 'Singapore',
    zh_name: '新加坡',
    code: 'SG',
    area_code: '65',
    domain_suffix: '.sg',
    latlng: {lat: 1.352083, lng: 103.819836}
  },
  {
    id: 188,
    en_name: 'Slovakia',
    zh_name: '斯洛伐克',
    code: 'SK',
    area_code: '421',
    domain_suffix: '.sk',
    latlng: {lat: 48.669026, lng: 19.699024}
  },
  {
    id: 189,
    en_name: 'Slovenia',
    zh_name: '斯洛文尼亚',
    code: 'SI',
    area_code: '386',
    domain_suffix: '.si',
    latlng: {lat: 46.151241, lng: 14.995463}
  },
  {
    id: 190,
    keywords: ['Solomon'],
    en_name: 'Solomon Islands',
    zh_name: '所罗门群岛',
    code: 'SB',
    area_code: '677',
    domain_suffix: '.sb',
    latlng: {lat: -9.64571, lng: 160.156194}
  },
  {
    id: 191,
    en_name: 'Somalia',
    zh_name: '索马里',
    code: 'SO',
    area_code: '252',
    domain_suffix: '.so',
    latlng: {lat: 5.152149, lng: 46.199616}
  },
  {
    id: 192,
    en_name: 'South Africa',
    zh_name: '南非',
    code: 'ZA',
    area_code: '27',
    domain_suffix: '.za',
    latlng: {lat: 5.152149, lng: 46.199616}
  },
  {
    id: 193,
    en_name: 'Spain',
    zh_name: '西班牙',
    code: 'ES',
    area_code: '34',
    domain_suffix: '.es',
    latlng: {lat: 40.463667, lng: -3.74922}
  },
  {
    id: 194,
    en_name: 'Sri Lanka',
    zh_name: '斯里兰卡',
    code: 'LK',
    area_code: '94',
    domain_suffix: '.lk',
    latlng: {lat: 7.873054, lng: 80.771797}
  },
  {
    id: 195,
    en_name: 'Sudan',
    zh_name: '苏丹',
    code: 'SD',
    area_code: '249',
    domain_suffix: '.sd',
    latlng: {lat: 12.862807, lng: 30.217636}
  },
  {
    id: 196,
    en_name: 'Suriname',
    zh_name: '苏里南',
    code: 'SR',
    area_code: '597',
    domain_suffix: '.sr',
    latlng: {lat: 3.919305, lng: -56.027783}
  },
  {
    id: 197,
    en_name: 'Swaziland',
    zh_name: '斯威士兰',
    code: 'SZ',
    area_code: '268',
    domain_suffix: '.sz',
    latlng: {lat: -26.522503, lng: 31.465866}
  },
  {
    id: 198,
    en_name: 'Sweden',
    zh_name: '瑞典',
    code: 'SE',
    area_code: '46',
    domain_suffix: '.se',
    latlng: {lat: 60.128161, lng: 18.643501}
  },
  {
    id: 199,
    en_name: 'Switzerland',
    zh_name: '瑞士',
    code: 'CH',
    area_code: '41',
    domain_suffix: '.ch',
    latlng: {lat: 46.818188, lng: 8.227512}
  },
  {
    id: 200,
    en_name: 'Syria',
    zh_name: '叙利亚',
    code: 'SY',
    area_code: '963',
    domain_suffix: '.sy',
    latlng: {lat: 34.802075, lng: 38.996815}
  },
  {
    id: 201,
    en_name: 'Tajikistan',
    zh_name: '塔吉克斯坦',
    code: 'TJ',
    area_code: '992',
    domain_suffix: '.tj',
    latlng: {lat: 38.861034, lng: 71.276093}
  },
  {
    id: 202,
    en_name: 'Tanzania',
    zh_name: '坦桑尼亚',
    code: 'TZ',
    area_code: '255',
    domain_suffix: '.tz',
    latlng: {lat: -6.369028, lng: 34.888822}
  },
  {
    id: 203,
    keywords: ['Taiwan (China)', '台湾'],
    en_name: 'Taiwan',
    zh_name: '台湾 (中国)',
    code: 'TW',
    area_code: '886',
    domain_suffix: '.tw',
    latlng: {lat: 23.69781, lng: 120.960515}
  },
  {
    id: 204,
    en_name: 'Thailand',
    zh_name: '泰国',
    code: 'TH',
    area_code: '66',
    domain_suffix: '.th',
    latlng: {lat: 15.870032, lng: 100.992541}
  },
  {
    id: 205,
    keywords: ['Trinidad', 'Tobago', '特立尼达', '多巴哥'],
    en_name: 'Trinidad and Tobago',
    zh_name: '特立尼达和多巴哥',
    code: 'TT',
    area_code: '1868',
    domain_suffix: '.tt',
    latlng: {lat: 10.691803, lng: -61.222503}
  },
  {
    id: 207,
    en_name: 'Togo',
    zh_name: '多哥',
    code: 'TG',
    area_code: '228',
    domain_suffix: '.tg',
    latlng: {lat: 8.619543, lng: 0.824782}
  },
  {
    id: 208,
    en_name: 'Tokelau',
    zh_name: '托克劳',
    code: 'TK',
    area_code: '690',
    domain_suffix: '.tk',
    latlng: {lat: -9.2002, lng: -171.8484}
  },
  {
    id: 209,
    en_name: 'Tonga',
    zh_name: '汤加',
    code: 'TO',
    area_code: '676',
    domain_suffix: '.to',
    latlng: {lat: -21.178986, lng: -175.198242}
  },
  {
    id: 210,
    en_name: 'Tunisia',
    zh_name: '突尼斯',
    code: 'TN',
    area_code: '216',
    domain_suffix: '.tn',
    latlng: {lat: 33.886917, lng: 9.537499}
  },
  {
    id: 211,
    en_name: 'Turkey',
    zh_name: '土耳其',
    code: 'TR',
    area_code: '90',
    domain_suffix: '.tr',
    latlng: {lat: 38.963745, lng: 35.243322}
  },
  {
    id: 212,
    en_name: 'Turkmenistan',
    zh_name: '土库曼斯坦',
    code: 'TM',
    area_code: '993',
    domain_suffix: '.tm',
    latlng: {lat: 38.969719, lng: 59.556278}
  },
  {
    id: 213,
    en_name: 'Tuvalu',
    zh_name: '图瓦卢',
    code: 'TV',
    area_code: '688',
    domain_suffix: '.tv',
    latlng: {lat: -7.109535, lng: 177.64933}
  },
  {
    id: 214,
    en_name: 'Uganda',
    zh_name: '乌干达',
    code: 'UG',
    area_code: '256',
    domain_suffix: '.ug',
    latlng: {lat: 1.373333, lng: 32.290275}
  },
  {
    id: 215,
    en_name: 'Ukraine',
    zh_name: '乌克兰',
    code: 'UA',
    area_code: '380',
    domain_suffix: '.ua',
    latlng: {lat: 48.379433, lng: 31.1655799}
  },
  {
    id: 216,
    en_name: 'United Arab Emirates',
    zh_name: '阿拉伯联合酋长国',
    code: 'AE',
    area_code: '971',
    domain_suffix: '.ae',
    latlng: {lat: 23.424076, lng: 53.847818}
  },
  {
    id: 217,
    keywords: ['U.K.', 'England'],
    en_name: 'United Kingdom',
    zh_name: '英国',
    code: 'GB',
    area_code: '44',
    domain_suffix: '.uk',
    latlng: {lat: 55.378051, lng: -3.435973}
  },
  {
    id: 219,
    en_name: 'Uruguay',
    zh_name: '乌拉圭',
    code: 'UY',
    area_code: '598',
    domain_suffix: '.uy',
    latlng: {lat: -32.522779, lng: -55.765835}
  },
  {
    id: 220,
    en_name: 'Uzbekistan',
    zh_name: '乌兹别克斯坦',
    code: 'UZ',
    area_code: '998',
    domain_suffix: '.uz',
    latlng: {lat: 41.377491, lng: 64.585262}
  },
  {
    id: 221,
    en_name: 'Vanuatu',
    zh_name: '瓦努阿图',
    code: 'VU',
    area_code: '678',
    domain_suffix: '.vu',
    latlng: {lat: -15.376706, lng: 166.959158}
  },
  {
    id: 222,
    en_name: 'Vatican City',
    zh_name: '梵蒂冈',
    code: 'VA',
    area_code: '379',
    domain_suffix: '.va',
    latlng: {lat: 41.902916, lng: 12.453389}
  },
  {
    id: 223,
    en_name: 'Venezuela',
    zh_name: '委内瑞拉',
    code: 'VE',
    area_code: '58',
    domain_suffix: '.ve',
    latlng: {lat: 6.42375, lng: -66.58973}
  },
  {
    id: 224,
    en_name: 'Vietnam',
    zh_name: '越南',
    code: 'VN',
    area_code: '84',
    domain_suffix: '.vn',
    latlng: {lat: 14.058324, lng: 108.277199}
  },
  {
    id: 225,
    keywords: ['Wallis', 'Futuna'],
    en_name: 'Wallis and Futuna',
    zh_name: '瓦利斯群岛和富图纳群岛',
    code: 'WF',
    area_code: '681',
    domain_suffix: '.wf',
    latlng: {lat: -14.2938, lng: -178.1165}
  },
  {
    id: 226,
    en_name: 'Western Sahara',
    zh_name: '西撒哈拉',
    code: 'EH',
    area_code: '685',
    domain_suffix: '.eh',
    latlng: {lat: 24.215527, lng: -12.885834}
  },
  {
    id: 227,
    en_name: 'Yemen',
    zh_name: '也门',
    code: 'YE',
    area_code: '967',
    domain_suffix: '.ye',
    latlng: {lat: 15.552727, lng: 48.516388}
  },
  {
    id: 228,
    en_name: 'Yugoslavia',
    zh_name: '南斯拉夫',
    code: 'YU',
    area_code: '381',
    domain_suffix: '.yu',
    latlng: {lat: 44.786568, lng: 20.4489216}
  },
  {
    id: 229,
    en_name: 'Zambia',
    zh_name: '赞比亚',
    code: 'ZM',
    area_code: '260',
    domain_suffix: '.zm',
    latlng: {lat: -13.133897, lng: 27.849332}
  },
  {
    id: 230,
    en_name: 'Zimbabwe',
    zh_name: '津巴布韦',
    code: 'ZW',
    area_code: '263',
    domain_suffix: '.zw',
    latlng: {lat: -19.015438, lng: 29.154857}
  },
  {
    id: 231,
    en_name: 'Afghanistan',
    zh_name: '阿富汗',
    code: 'AF',
    area_code: '93',
    domain_suffix: '.af',
    latlng: {lat: 33.93911, lng: 67.709953}
  },
  {
    id: 232,
    keywords: ['Cayman'],
    en_name: 'Cayman Islands',
    zh_name: '开曼群岛',
    code: 'KY',
    area_code: '1345',
    domain_suffix: '.ky',
    latlng: {lat: 19.3133, lng: -81.2546}
  },
  {
    id: 233,
    en_name: 'Greenland',
    zh_name: '格陵兰岛',
    code: 'GL',
    area_code: '299',
    domain_suffix: '.gl',
    latlng: {lat: 71.706936, lng: -42.604303}
  },
  {
    id: 234,
    en_name: 'Kosovo',
    zh_name: '科索沃',
    code: 'KV',
    area_code: '381',
    domain_suffix: '',
    latlng: {lat: 42.6026359, lng: 20.902977}
  }
]

coutryBase.forEach(e => {
  if (e.keywords) e.keywords.map(v => v.toLowerCase())
})

coutryBase.sort(function (v1, v2) {
  if (v1.code > v2.code) {
    return 1
  } else if (v1.code < v2.code) {
    return -1
  } else {
    return 0
  }
})

export interface Country extends CountryBase {
  position: number
  sort: number
}

let i = 0

class CountryClass {
  codeCountry: {[key: string]: Country} = {}

  idCountry: {[key: string]: Country} = {}

  constructor() {
    this.list.forEach(v => {
      this.codeCountry[v.code] = v
      this.idCountry[v.id] = v
    })
  }

  //按国家区号排序的国家数组
  get areaCodes() {
    return Object.freeze([...this.list].sort((v1, v2) => (~~v1.area_code > ~~v2.area_code ? -1 : 1)))
  }

  get list() {
    let data = coutryBase.map((v, index) => {
      var ids = [34, 137, 50, 87, 204, 224, 142]
      let position = -(index * 32),
        sort: number = 0
      let bool = ids.some((v2, index) => {
        if (v.id === v2) {
          sort = -(ids.length - index)
          return true
        }
      })
      if (!bool) {
        sort = i++
      }

      return {
        position,
        sort,
        ...v
      }
    })

    data.sort(function (v1, v2) {
      if (v1.sort > v2.sort) {
        return 1
      } else if (v1.sort < v2.sort) {
        return -1
      } else {
        return 0
      }
    })

    return data
  }

  /**
   * 获取国家详细信息
   * @param country_id 国家id
   * @language 语言，可选值 cn|en
   * @return {Country|null}
   * */
  get(country_id: number | string, language: string = 'en') {
    if (language !== 'cn') language = 'en'
    let data = this.idCountry[country_id]
    if (data) {
      return {
        name: language === 'en' ? data.en_name : data.zh_name,
        ...data
      }
    } else {
      return null
    }
  }

  /**
   * 去除地地址位置的国家信息
   * @param geo {string} 地址
   * */
  clearCountry(geo: string) {
    let str = geo

    this.list.some(val => {
      let reg = new RegExp('^' + val.zh_name, 'g')
      if (reg.test(geo)) {
        str = geo.replace(reg, '')
        return true
      }

      reg = new RegExp(val.en_name + '$', 'g')
      if (reg.test(val.en_name)) {
        str = geo.replace(reg, '')
        return true
      }

      reg = new RegExp(val.code + '$', 'g')
      if (reg.test(val.code)) {
        str = geo.replace(reg, '')
        return true
      }
    })

    return ff.util.rtrim(ff.util.trim(str), ',')
  }

  /**
   * 搜索国家
   * @param key {string} 搜索关键字全称，关键字可以是 国家英文名，国家中文名，国家大写代码，国家区号
   * 也有可能类似"Bangkok, Thailand"，"Bangkok, HK" 这样的字符串
   * @return 匹配到的第一个对象
   * */
  search(key: string): Country | undefined {
    if (!key) return
    if (key === 'UK') key = 'GB'
    else if (key.includes('香港')) key = 'HK'
    else if (key.includes('澳门') || key.includes('Macau')) key = 'MO'
    if (key) {
      let newKey = ff.util.trim(key)

      if (key.indexOf(',') > 0) {
        let a = key.split(/, ?/)
        newKey = ff.util.trim(a[a.length - 1])
      }

      let s = newKey.replace(/\+/g, '').toLowerCase()

      let data = this.list.find(val => val.en_name.toLowerCase() === s)

      if (!data) {
        data = this.list.find(val => val.zh_name === s)
      }
      if (!data) {
        data = this.codeCountry[s.toUpperCase()]
      }

      if (!data) {
        data = this.list.find(val => val.area_code === s)
      }

      if (!data) {
        data = this.list.find(val => val.keywords && val.keywords.includes(s))
      }

      if (!data) {
        //正则匹配国家代码
        data = this.list.find(val => {
          let reg = new RegExp('(^|[\\s,;:.])' + val.code + '([\\s,;:.]|$)')
          return reg.test(key)
        })
      }
      if (data) {
        return JSON.parse(JSON.stringify(data))
      } else {
        return
      }
    } else {
      return
    }
  }

  /**
   * 通过国家 code 查询国家对象
   * @param {String} code 国家code;
   * */
  searchByCode(code: string): Country | undefined {
    if (!code) {
      return undefined
    } else {
      code = code.toUpperCase()
      if (code === 'UK') code = 'GB'

      return this.codeCountry[code]
    }
  }

  /**
   * 获取电话中的国家区号
   * @param phone {string} 带国家区号的电话
   * */
  getPhoneAreaCode(phone: string) {
    let d = phone.replace(/[+ ]/g, '')
    let areaCode = ''
    this.areaCodes.forEach((v: Country) => {
      if (d.indexOf(v.area_code) === 0) {
        if (areaCode.length < v.area_code.length) {
          areaCode = v.area_code
        }
      }
    })
    return areaCode
  }

  //通过国家区号查Country对象
  searchByAreaCode(str: string) {
    return this.areaCodes.find((v: Country) => str.indexOf(v.area_code) === 0)
  }
}

export default CountryClass
