interface ItemReturn {
    text: string;
    data: string[];
}
interface ContactInfoAndWebsite {
    info: f2.info.Info[];
    text: string;
    website: string[];
}
export default class AnalyzeText {
    isCompany: boolean;
    constructor(isCompany?: boolean);
    static getCommon(text: string, reg: RegExp, isUrl?: boolean): ItemReturn;
    static getCommonExclude1(text: string, reg: RegExp, excludes: string[], isUrl?: boolean): ItemReturn;
    getDataInfo(arr: string[], type: f2.info.Type): {
        type: f2.info.Type;
        info: string;
    }[];
    getContactInfo(text: string, hasGetWebSite?: boolean): ContactInfoAndWebsite;
    getMediaContactInfo(text: string, getAll?: boolean): {
        contactInfos: f2.info.Info[];
        companyInfos: f2.info.Info[];
        text: string;
    };
    getWebSite(text: string): ItemReturn;
    getFacebook(text: string, isCompany?: boolean): ItemReturn;
    getJd(text: string): ItemReturn;
    getWiki(text: string): ItemReturn;
    getTwitter(text: string): ItemReturn;
    getInstagram(text: string): ItemReturn;
    getZhihu(text: string, isCompany?: boolean): ItemReturn;
    getItjuzi(text: string, isCompany?: boolean): ItemReturn;
    getCraft(text: string): ItemReturn;
    getPedaily(text: string, isCompany?: boolean): ItemReturn;
    getCyzone(text: string, isCompany?: boolean): ItemReturn;
    getCrunchbase(text: string, isCompany?: boolean): ItemReturn;
    getPaganresearch(text: string): ItemReturn;
    getYoutube(text: string): ItemReturn;
    getPinterest(text: string): ItemReturn;
    get1688(text: string): ItemReturn;
    getAlibaba(text: string): ItemReturn;
    getTmall(text: string): ItemReturn;
    getEbay(text: string): ItemReturn;
    getAmazon(text: string): ItemReturn;
    getWordpress(text: string, isCompany?: boolean): ItemReturn;
    getWeibo(text: string): ItemReturn;
    getLinkedin(text: string, isCompany?: boolean): ItemReturn;
    getGithub(text: string): ItemReturn;
    getWsj(text: string, isCompany?: boolean): ItemReturn;
    getMedium(text: string, isCompany?: boolean): ItemReturn;
    getDnb(text: string): ItemReturn;
    getOpencorporates(text: string): ItemReturn;
    getTianyancha(text: string, isCompany?: boolean): ItemReturn;
    getQcc(text: string, isCompany?: boolean): ItemReturn;
    getQixin(text: string, isCompany?: boolean): ItemReturn;
    getAs(text: string): ItemReturn;
    getEmail(text: string): ItemReturn;
    getWechat(text: string): ItemReturn;
    getQq(text: string): ItemReturn;
    getSkype(text: string): ItemReturn;
    getPhone(text: string): ItemReturn;
}
export {};
